leetcode:Combination Sum 【Java】

一、问题描述

Given a set of candidate numbers (C) and a target number (T), find all unique combinations in C where the candidate numbers sums to T.

The same repeated number may be chosen from C unlimited number of times.

Note:

  • All numbers (including target) will be positive integers.
  • Elements in a combination (a1a2, … , ak) must be in non-descending order. (ie, a1 ≤ a2 ≤ … ≤ ak).
  • The solution set must not contain duplicate combinations.

For example, given candidate set 2,3,6,7 and target 7
A solution set is: 
[7] 
[2, 2, 3] 

二、问题分析

1、采用递归算法;

2、详见代码注释。

三、算法代码

public class Solution {
    public List<List<Integer>> combinationSum(int[] candidates, int target) {
        Arrays.sort(candidates);
        ArrayList<Integer> cur = new ArrayList<Integer>();
        List<List<Integer>> result = new ArrayList<List<Integer>>();
        dfs(candidates, target, 0, cur, result);
        return result;
    }
    
    public void dfs(int[] candidates, int gap, int start, ArrayList<Integer> cur, List<List<Integer>> result){
        if(gap == 0){
            result.add(cur);
            return;
        }
        for(int i = start; i < candidates.length; i++){
            if(gap < candidates[i]){
                return;
            }
            cur.add(candidates[i]);
            //做两点说明
            //1、因为元素可以重复,所以第三个参数是i而不是i + 1
            //2、第四个参数是new ArrayList(cur),而不是cur,需要每次递归都创建一个保存中间结果的容器
            dfs(candidates, gap - candidates[i], i, new ArrayList(cur), result);
            cur.remove(cur.size() - 1);
        }
    }
}


你可能感兴趣的:(LeetCode)